`Heroku.Types`
==============

This module defines some essential types the [Heroku Partner API][addon-partner-api] uses.

Module Header
-------------

```haskell
{-# LANGUAGE DeriveGeneric #-}

-- | This file is a literate haskell document. Please see the source code for more information.
module Heroku.Types

import Data.Aeson
import Data.Text
import GHC.Generics
```

Provision Request
-----------------

This datatype is defined [here][provision-type].

```haskell
data Provision = Provision
               { heroku_id     :: Text
               , plan          :: Text
               , region        :: Text
               , callback_url  :: Text
               , options       :: Object -- Generic "anything" for JSON data
               , uuid          :: Text
               , log_input_url :: Text
               } deriving (Read, Show, Eq, Generic)

instance ToJSON Provision
instance FromJSON Provision
```

---
[addon-partner-api]: https://devcenter.heroku.com/articles/add-on-partner-api
[provision-type]: https://devcenter.heroku.com/articles/add-on-partner-api#provision
